/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.AnagDspRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class AnagDsp extends TableImpl<AnagDspRecord> {

    private static final long serialVersionUID = -572715987;

    /**
     * The reference instance of <code>ANAG_DSP</code>
     */
    public static final AnagDsp ANAG_DSP = new AnagDsp();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<AnagDspRecord> getRecordType() {
        return AnagDspRecord.class;
    }

    /**
     * The column <code>ANAG_DSP.IDDSP</code>.
     */
    public final TableField<AnagDspRecord, String> IDDSP = createField("IDDSP", org.jooq.impl.SQLDataType.VARCHAR(100).nullable(false), this, "");

    /**
     * The column <code>ANAG_DSP.CODE</code>.
     */
    public final TableField<AnagDspRecord, String> CODE = createField("CODE", org.jooq.impl.SQLDataType.VARCHAR(10).nullable(false), this, "");

    /**
     * The column <code>ANAG_DSP.NAME</code>.
     */
    public final TableField<AnagDspRecord, String> NAME = createField("NAME", org.jooq.impl.SQLDataType.VARCHAR(100).nullable(false), this, "");

    /**
     * The column <code>ANAG_DSP.DESCRIPTION</code>.
     */
    public final TableField<AnagDspRecord, String> DESCRIPTION = createField("DESCRIPTION", org.jooq.impl.SQLDataType.VARCHAR(200), this, "");

    /**
     * The column <code>ANAG_DSP.FTP_SOURCE_PATH</code>.
     */
    public final TableField<AnagDspRecord, String> FTP_SOURCE_PATH = createField("FTP_SOURCE_PATH", org.jooq.impl.SQLDataType.VARCHAR(45), this, "");

    /**
     * Create a <code>ANAG_DSP</code> table reference
     */
    public AnagDsp() {
        this(DSL.name("ANAG_DSP"), null);
    }

    /**
     * Create an aliased <code>ANAG_DSP</code> table reference
     */
    public AnagDsp(String alias) {
        this(DSL.name(alias), ANAG_DSP);
    }

    /**
     * Create an aliased <code>ANAG_DSP</code> table reference
     */
    public AnagDsp(Name alias) {
        this(alias, ANAG_DSP);
    }

    private AnagDsp(Name alias, Table<AnagDspRecord> aliased) {
        this(alias, aliased, null);
    }

    private AnagDsp(Name alias, Table<AnagDspRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> AnagDsp(Table<O> child, ForeignKey<O, AnagDspRecord> key) {
        super(child, key, ANAG_DSP);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.ANAG_DSP_CODE_UNIQUE, Indexes.ANAG_DSP_NAME_UNIQUE, Indexes.ANAG_DSP_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<AnagDspRecord> getPrimaryKey() {
        return Keys.KEY_ANAG_DSP_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<AnagDspRecord>> getKeys() {
        return Arrays.<UniqueKey<AnagDspRecord>>asList(Keys.KEY_ANAG_DSP_PRIMARY, Keys.KEY_ANAG_DSP_CODE_UNIQUE, Keys.KEY_ANAG_DSP_NAME_UNIQUE);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public AnagDsp as(String alias) {
        return new AnagDsp(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public AnagDsp as(Name alias) {
        return new AnagDsp(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public AnagDsp rename(String name) {
        return new AnagDsp(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public AnagDsp rename(Name name) {
        return new AnagDsp(name, null);
    }
}
